"""
Name	:	unlimited 'bobs' - korruptor, http://www.korruptor.demon.co.uk
Desc	:

I first saw this in the Dragons MegaDemo on the A500 back in '89 and it blew me away. 
How gutted I was when Wayne "tripix" Keenan told me how easy it was and knocked up an 
an example demo a couple of years later.

For those of you that didn't know how it was done, here's a pygame example. It's 
basically a flick-book effect; you draw the same sprite in different positions on 
25 different 'screens' and flick between them. When you've drawn on all 25 you loop 
back to the beginning and keep on blitting. 

Sprite offsets make it look like you're adding sprites. Simple.
"""

import pygame, pygame.image
from pygame.surfarray import *
from pygame.locals import *
from math import *


# ------------------------------------------------------------------------------------

RES 		= (480,400)
PI 		= 3.14159
DEG2RAD 	= PI/180
SURFS           = []

# ------------------------------------------------------------------------------------
def main():
     
    	# Initialise pygame, and grab an 8bit display.
    	pygame.init()
    	screen		= pygame.display.set_mode(RES,0, 8)
        bob		= pygame.image.load("bob.gif")
        
        # load a sprite and set the palette
        bob.set_colorkey((255,255,255))
        screen.set_palette(bob.get_palette())
            

        # Create 25 blank surfaces to draw on.
        for i in range(0,25):
            SURFS.append(pygame.Surface(RES,0,8))
            SURFS[i].set_palette(bob.get_palette())

        xang    = 0.0
        yang    = 0.0
        surf    = 0
        
        # Fruity loops...
        while 1:
    
            # Have we received an event to quit the program?
            for e in pygame.event.get():
                if e.type in (QUIT,KEYDOWN,MOUSEBUTTONDOWN):
                    return


            # Get some x/y positions
            x = (RES[0]/2)*sin((xang*DEG2RAD)*0.75)
            y = (RES[1]/2)*cos((yang*DEG2RAD)*0.67)
  
            # Inc the angle of the sine
            xang += 1.17
            yang += 1.39
        
            # blit our 'bob' on the 'active' surface
            SURFS[surf].blit(bob,(x+(RES[0]/2)-32,y+(RES[1]/2)-32))
            
            # blit the active surface to the screen
            screen.blit(SURFS[surf],(0,0))

            # display the results
            pygame.display.flip()

            # inc the active surface number
            surf = (surf+1) % 25
            
        # Bye!
        return

# ------------------------------------------------------------------------------------
if __name__ == '__main__': main()
# End of sauce. Pass the chips...


